package com.dml.crawler.callback.bean;

import lombok.Data;

import java.io.Serializable;

@Data
public class ApiResponse<T> implements Serializable {

    private static final long serialVersionUID = 4284089640162103356L;
    private int code;
    private String message;
    private T data;

    public ApiResponse() {
    }

    public ApiResponse(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public static <T> ApiResponse<T> success(T data) {
        ApiResponse<T> res = success();
        res.setData(data);
        return res;
    }

    public static <T> ApiResponse<T> success() {
        ApiResponse<T> apiResponse = new ApiResponse<T>();
        apiResponse.setCode(0);
        apiResponse.setMessage("ok");
        return apiResponse;
    }

    public static <T> ApiResponse<T> fail(int code, String message) {
        return new ApiResponse<>(code, message);
    }

}
